/*
 auto trucking for equatorial
 servo moter SG90
 2016.09.11
*/
#include <stdio.h>
#include <stdlib.h>
#include <wiringPi.h>
#include <unistd.h>

#define BASE_CLOCK 192
#define MIN_WIDTH  630 //usec
#define MAX_WIDTH 2500 //usec
#define SG90_ANGLE 180
#define RA 13
#define DEC 18

int main(int ac, char *av[])
{
  int pwm_range = 4000;
  int pwm_clock = atoi(av[1]);
  int pwm_min = (MIN_WIDTH * BASE_CLOCK) / (pwm_clock * 10);
  int pwm_max = (MAX_WIDTH * BASE_CLOCK) / (pwm_clock * 10);
  int wait    =  12 * 3600 /(pwm_max - pwm_min) * 1000000;
//  int wait    =  12 * 3600 /(pwm_max - pwm_min) * 1000;


  int ra  = atoi(av[2]);
  int pwm_ra  =  pwm_min + (pwm_max - pwm_min) / SG90_ANGLE * (90 - ra);

  int dec = atoi(av[3]);
  int pwm_dec =  pwm_min + (pwm_max - pwm_min) / SG90_ANGLE * (90 - dec);

  if (wiringPiSetupGpio() == -1) {
    printf("cannot setup gpio.");
    return 1;
  }

  pinMode(RA,  PWM_OUTPUT);
  pinMode(DEC, PWM_OUTPUT);
  pwmSetMode(PWM_MODE_MS);
  pwmSetClock(pwm_clock);
  pwmSetRange(pwm_range);

  pwmWrite(DEC, pwm_dec);
  pwmWrite(RA, pwm_ra);

  return 0;
}
